const urlParams = new URLSearchParams(window.location.search);
const entityName = urlParams.get('entityName');

function getEntityDisplayTitle(entityName) {
    switch (entityName) {
        case "LookupTables": return "Lookup Table";
        case "LookupTableEntries": return "Lookup Entry";
        case "CustomFields": return "Custom Field";
        case "ProjectDetailPages": return "Project Detail Page";
        case "EnterpriseProjectTypes": return "Enterprise Project Type";
        case "EnterpriseResources": return "Enterprise Resource";
        case "SiteColumns": return "Site Column";
        case "ContentTypes": return "Content Type";
        default: return "!! Unhandled Entity Type !!";
    }
}

async function loadFile(file) {
    window.entityCount = null
    button = document.getElementById("saveSelect");
    window.name = document.getElementById("tfileWork").value;
    var selectionTableTitle = document.getElementById("selection")
    window.name = file.name;
    var text = await file.text();
    window.pwaConfig = JSON.parse(text);
    var Trows = document.getElementById("neTable").rows.length;
    for (let i = 0; i < Trows; i++) {
        document.getElementById("neTable").deleteRow(-1);
    }
    for (let i = 0; i < Object.keys(pwaConfig).length; i++) {
        if (Object.keys(pwaConfig)[i] == entityName) {
            entityCount = i
        }
    }
    if (entityCount != null) {
        button.disabled = false;
        selectionTableTitle.innerHTML = "Selection"
        selectionTableTitle.style.color = "#262626"
        for (let i = 0; i < Object.values(pwaConfig)[entityCount].length; i++) {

            if (Object.values(pwaConfig)[entityCount][i].Selected != true) {
                Object.values(pwaConfig)[entityCount][i].Selected = false;
            }
            const chek = document.createElement('input');
            chek.type = "checkbox";
            chek.id = "chk" + i;
            if (Object.values(pwaConfig)[entityCount][i].Selected == true) {
                chek.checked = true;
            }
            const att = document.createAttribute("onchange");
            att.value = "selection(" + i + ")";
            chek.setAttributeNode(att);
            var x = document.getElementById("neTable").insertRow(-1);
            var y = x.insertCell(0);
            var z = x.insertCell(1);
            y.appendChild(chek);
            switch (entityName) {
                case "CustomFields":
                    {
                        z.innerHTML = `${Object.values(pwaConfig)[entityCount][i].Name} [${Object.values(pwaConfig)[entityCount][i].EntityType.Name}]`;
                        break;
                    }
                case "SiteColumns":
                    {
                        z.innerHTML = `${Object.values(pwaConfig)[entityCount][i].Title} [${Object.values(pwaConfig)[entityCount][i].StaticName}]`;
                        break;
                    }
                default: {
                    z.innerHTML = Object.values(pwaConfig)[entityCount][i].Name;
                }
            }
        }
    } else {
        button.disabled = true
        selectionTableTitle.innerHTML = "File does not include " + entityName
        selectionTableTitle.style.color = "DarkRed"
    }
    selectionTableTitle.style.visibility = "visible";
}

function selection(num) {
    if (Object.values(pwaConfig)[entityCount][num].Selected == false) {
        Object.values(pwaConfig)[entityCount][num].Selected = true
    } else {
        Object.values(pwaConfig)[entityCount][num].Selected = false
    }
}

async function handleSaveJSON(event) {
    //if (entityName == "LookupTables") {
    //    var pwaConfig = {
    //        LookupTables: Object.values(pwaConfig)[entityCount]
    //    };
    //}; if (entityName == "LookupTableEntries") {
    //    var pwaConfig = {
    //        LookupTableEntries: Object.values(pwaConfig)[entityCount]
    //    };
    //}; if (entityName == "CustomFields") {
    //    var pwaConfig = {
    //        CustomFields: Object.values(pwaConfig)[entityCount]
    //    };
    //}; if (entityName == "ProjectDetailPages") {
    //    var pwaConfig = {
    //        ProjectDetailPages: Object.values(pwaConfig)[entityCount]
    //    };
    //}; if (entityName == "EnterpriseProjectTypes") {
    //    var pwaConfig = {
    //        EnterpriseProjectTypes: Object.values(pwaConfig)[entityCount]
    //    };
    //}; if (entityName == "EnterpriseResources") {
    //    var pwaConfig = {
    //        EnterpriseResources: Object.values(pwaConfig)[entityCount]
    //    };
    //}; if (entityName == "SiteColumns") {
    //    var pwaConfig = {
    //        SiteColumns: Object.values(pwaConfig)[entityCount]
    //    };
    //}; if (entityName == "ContentTypes") {
    //    var pwaConfig = {
    //        ContentTypes: Object.values(pwaConfig)[entityCount]
    //    };
    //};
    
    //const blob = new Blob([JSON.stringify(pwaConfig, null, 4)], { type: "application/json" });
    const blob = new Blob([JSON.stringify(window.pwaConfig, null, 4)], { type: "application/json" });
    const opts = {
        suggestedName: name,
        types: [
            {
                description: "JSON file",
                accept: { "JSON/*": ".json" },
            },
        ],
    };
    if (window.showSaveFilePicker) {
        const handle = await showSaveFilePicker(opts);
        const writable = await handle.createWritable();
        await writable.write(blob);
        writable.close();
    }
    else {
        const link = document.createElement('a');
        link.href = URL.createObjectURL(blob);
        link.download = entityName + ".json";
        link.click();
        setTimeout(() => URL.revokeObjectURL(link.href), 60000);
    }
}

document.getElementById("selectionTitle").innerHTML = getEntityDisplayTitle(entityName) + " Selection";