// Ensure the global SP and PS variables are defined
/// <reference path="PS.debug.js" />
/// <reference path="SP.debug.js" />
/// <reference path="SP.Runtime.js" />
var SP = SP || {};
var PS = PS || {};

class IOPWAViews extends IOBaseEntity {
    constructor(apiUrl, fileInput, logTextArea, progressBar) {
        super(apiUrl, fileInput, logTextArea, progressBar);
    }

    get_name() {
        return "PWA Views";
    }

    async export() {
        throw new Error("Microsoft have not published a JSOM or CSOM or REST api to export or import views. Microsoft have also completely disabled the old Project.asmx web service that used to provide this functionality. :(");

        //this.startNewLog("Retrieving PWA Views");

        //this.callPSI();

        //    //Using REST
        //const data = await this.getViews(this.apiUrl);
        ////    const lookupTables = data.value;
        ////    this.appendLog(`Found ${lookupTables.length} Lookup Tables in PWA`);
        //var link = document.createElement("a");
        //link.download = 'PWAViews.xml';
        //link.href = "data:text/xml;charset=utf-8," + encodeURIComponent(data);
        //document.body.appendChild(link);
        //link.click();
        //document.body.removeChild(link);
    }



    async import() {
        throw new Error("Microsoft have not published a JSOM or CSOM or REST api to export or import views. Microsoft have also completely disabled the old Project.asmx web service that used to provide this functionality. :(");
        //return new Promise(async (resolve, reject) => {
        //    try {
        //        this.startNewLog('');

        //        const file = this.openFile();
        //        //this.appendLog("Reading Lookup Tables from file");
        //        //const fileContent = await this.readFileAsText(file);
        //        ////const lookupTables = JSON.parse(fileContent);

        //        //var count = lookupTables.length;
        //        //this.appendLog(`Found ${count} Lookup Tables in file`);
        //        //let projectContext = PS.ProjectContext.get_current();

        //    }
        //    catch
        //    {
        //        reject(error);
        //    }
        //});
    }


    callPSI() {
    var siteurl = _spPageContextInfo.siteAbsoluteUrl;
    var soapenv =
        `<?xml version="1.0" encoding="utf-8"?>
        <soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
            xmlns:xsd="http://www.w3.org/2001/XMLSchema" 
            xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
            <soap:Body>
                <ReadProjectStatus xmlns="http://schemas.microsoft.com/office/project/server/webservices/Project/">
                    <projectUid>0c455622-6c3d-ed11-95e6-00224895c631</projectUid>
                    <xmlFilter/>
                </ReadProjectStatus>
            </soap:Body>
        </soap:Envelope>`;

    fetch(siteurl + "/_vti_bin/PSI/Project.asmx", {
        method: 'POST',
        headers: {
            'Content-Type': 'text/xml; charset=utf-8',
            'SOAPAction': 'http://schemas.microsoft.com/office/project/server/webservices/Project/ReadProjectStatus'
        },
        credentials: 'include',
        body: soapenv
    })
        .then(response => {
            if (!response.ok) {
                throw new Error(`HTTP error! status: ${response.status}`);
            }
            return response.text();
        })
        .then(str => (new window.DOMParser()).parseFromString(str, "text/xml"))
        .then(data => console.log(data))
        .catch(e => console.log(e));
}






    async getViews(apiUrl) {

        //TODO: NOT WORKING
        return new Promise(function (resolve, reject) {
            const soapRequest = `<?xml version="1.0" encoding="utf-8"?>
              <soap:Envelope xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/" xmlns:proj="http://schemas.microsoft.com/office/project/server/webservices/ProjectServerServices">
                <soap:Body>
                  <proj:ReadViews>
                    <proj:viewType>0</proj:viewType>
                  </proj:ReadViews>
                </soap:Body>
              </soap:Envelope>`;


            var wsUrl = `${apiUrl}/_vti_bin/PSI/Project.asmx`;
            SP.SOD.registerSod('SP.RequestExecutor.js', '/_layouts/15/SP.RequestExecutor.js');
            SP.SOD.executeFunc('SP.RequestExecutor.js', 'SP.RequestExecutor', function () {
                var executor = new SP.RequestExecutor();
                executor.executeAsync({
                    url: wsUrl,
                    method: 'POST',
                    body: soapRequest,
                    headers: {
                        'Content-Type': 'text/xml;charset=utf-8',
                        'SOAPAction': 'http://schemas.microsoft.com/office/project/server/webservices/ProjectServerServices/MethodName'
                    },
                    success: function (data) {
                        // Handle success response
                        resolve(data);
                    },
                    error: function (error) {
                        // Handle error response
                        reject(error);
                    }
                });
            });
        });
    }


    //async getViews() {
    //    const soapRequest = `<?xml version="1.0" encoding="utf-8"?>
    //<soap:Envelope xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/" xmlns:proj="http://schemas.microsoft.com/office/project/server/webservices/ProjectServerServices">
    //  <soap:Body>
    //    <proj:ReadViews>
    //      <proj:viewType>0</proj:viewType>
    //    </proj:ReadViews>
    //  </soap:Body>
    //</soap:Envelope>`;

    //    const response = await fetch("/_vti_bin/PSI/Project.asmx", {
    //        method: "POST",
    //        headers: {
    //            "Content-Type": "text/xml; charset=utf-8",
    //            SOAPAction: "http://schemas.microsoft.com/office/project/server/webservices/ProjectServerServices/ReadViews",
    //        },
    //        body: soapRequest,
    //    });

    //    if (response.ok) {
    //        const responseText = await response.text();
    //        const parser = new DOMParser();
    //        const xmlDoc = parser.parseFromString(responseText, "text/xml");

    //        // Extracting view information
    //        const views = xmlDoc.getElementsByTagName("View");
    //        this.appendLog(`Found ${views.length} views in PWA.`);
    //        //for (let i = 0; i < views.length; i++) {
    //        //    const view = views[i];
    //        //    const viewName = view.getAttribute("Name");
    //        //    const viewUid = view.getAttribute("Uid");
    //        //    // Extract other desired properties here...

    //        //    console.log(`View Name: ${viewName}`);
    //        //    console.log(`View Uid: ${viewUid}`);
    //        //    // Log other properties...
    //        //}

    //        console.log("Views retrieved successfully");
    //        return responseText;
    //    } else {
    //        throw new Error(`Failed to retrieve views from PWA:${response.status}`);
    //    }
    //}



    //function exportView(viewName) {
    //var soapRequest = '<?xml version="1.0" encoding="utf-8"?>' +
    //    '<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" ' +
    //    'xmlns:xsd="http://www.w3.org/2001/XMLSchema" ' +
    //    'xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">' +
    //    '<soap:Body>' +
    //    '<ReadView xmlns="http://schemas.microsoft.com/office/project/server/webservices/ProjectServerServices">' +
    //    '<viewName>' + viewName + '</viewName>' +
    //    '</ReadView>' +
    //    '</soap:Body>' +
    //    '</soap:Envelope>';

    //var xhr = new XMLHttpRequest();
    //xhr.open('POST', '/_vti_bin/PSI/Project.asmx', true);
    //xhr.setRequestHeader('Content-Type', 'text/xml; charset=utf-8');
    //xhr.setRequestHeader('SOAPAction', 'http://schemas.microsoft.com/office/project/server/webservices/ProjectServerServices/ReadView');
    //xhr.onreadystatechange = function () {
    //    if (xhr.readyState == 4) {
    //        if (xhr.status == 200) {
    //            var responseXml = xhr.responseXML;
    //            var schemaXml = responseXml.getElementsByTagName("ReadViewResponse")[0].getElementsByTagName("ReadViewResult")[0].childNodes[0].nodeValue;
    //            download(schemaXml, viewName + ".xml");
    //        } else {
    //            console.log('Failed to export view');
    //        }
    //    }
    //};
    //xhr.send(soapRequest);
}

